Subject: bug#50470: 27.1; 'company-mode' 'eshell'

From: Dmitry Gutov <[email-masked]>
Date: Sat, 18 Mar 2023 03:01:11 +0200

On 17/03/2023 08:26, Jim Porter wrote:
> I've recently been digging through how Eshell and Pcomplete interact, so 
> I think I understand what's happening here.

Thanks!

> On 6/7/2022 3:39 PM, Dmitry Gutov wrote:
>> pcomplete-completions-at-point somehow has pcomplete-stub pointing to 
>> the necessary value (e.g. "/home/dgutov/Do") in the asterisk-less 
>> cases (due to some other code path being taken), but not in this 
>> specific one.
> 
> I believe the problem is that when Eshell parses the command line to 
> figure out what to give Pcomplete, it expands the globs itself, so 
> things get messed up. So we want to prevent glob-expansion before 
> passing to Pcomplete.
> 
> The below patch does this, but it's probably not the right way to do it. 
>   However, it's a simple change, and before I go through the larger 
> effort of a proper patch, I want to be sure I'm actually solving the 
> right thing.

I can't comment on the exact right way to implement this, but the patch 
does seem to solve the remaining problem here. Which is completion for 
inputs containing *. The result looks rather nice.